/*	Formatleft  2010, ConnorMcLeod

	Drop All Weapons On Death is free software;
	you can redistribute it and/or modify it under the terms of the
	GNU General Public License as published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Drop All Weapons On Death; if not, write to the
	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.
*/
// hi compiler
#include <amxmodx>
#include <cstrike>
#include <engine>
#include <fakemeta>
#include <hamsandwich>

new const VERSION[] = "0.1.6"

const WPNBX_CUSTOM = -64815

// "weapon_..." offsets
const XTRA_OFS_WEAPON = 4
// nades specific
const m_flPinPulledOutTime = 31
// all weapons :
const m_pPlayer = 41
const m_pNext = 42

// "player" offsets
const XTRA_OFS_PLAYER = 5
// Store only slots 1,2 and 4 values cause we won't drop knife and let the game drop c4
new const m_rgpPlayerItems_plr[] = {368, 369, 371}
const m_pActiveItem = 373
const m_rgAmmo_Player_Slot0 = 376

// "weaponbox" offsets
const XTRA_OFS_WEAPONBOX = 4
const m_rgiszAmmo_Slot0 = 41
const m_rgAmmo_Slot0 = 73
new const m_rgpPlayerItems_wpnbx[] = {34, 35, 36, 37, 38, 39}

new const g_iMaxAmmo[] = {
	0, 30, 90, 200, 90,
	32, 100, 100, 35, 52,
	120, 2, 1, 1, 1
}

const NADES_BS = (1<<CSW_HEGRENADE)|(1<<CSW_FLASHBANG)|(1<<CSW_SMOKEGRENADE)

enum {
	DoNotRegister,
	CanRegister,
}

new g_iszAmmoNames[sizeof(g_iMaxAmmo)]

new g_bCzBotRegistered

new g_iNoSilPluginId, g_iNoSilSetModel

public plugin_init()
{
	register_plugin("Drop All Weapons On Death", VERSION, "ConnorMcLeod")

	register_event("HLTV", "Event_HLTV_New_Round", "a", "1=0", "2=0")

	RegisterHam(Ham_Killed, "player", "Player_Killed")

	new szAmmoNames[][] = {
		"", "338Magnum", "762Nato", "556NatoBox", "556Nato",
		"buckshot", "45ACP", "57mm", "50AE", "357SIG",
		"9mm", "Flashbang", "HEGrenade", "SmokeGrenade", "C4"
	}

	for(new i=1; i<sizeof(szAmmoNames); i++)
	{
		g_iszAmmoNames[i] = engfunc(EngFunc_AllocString, szAmmoNames[i])
	}

	new szModName[6]
	get_modname(szModName, charsmax(szModName))
	if( !equal(szModName, "czero") || cvar_exists("pb_version") )
	{
		g_bCzBotRegistered = true
	}
}

public plugin_cfg()
{
	g_iNoSilPluginId = is_plugin_loaded("NoSil")
	if( g_iNoSilPluginId > 0 )
	{
		g_iNoSilSetModel = get_func_id("fw_setmodel", g_iNoSilPluginId)
	}
}

public client_putinserver( id )
{
	if( !g_bCzBotRegistered && is_user_bot(id) )
	{
		set_task(0.1, "Task_Register_CzBots", id)
	}
}

public Task_Register_CzBots( id )
{
	if( !g_bCzBotRegistered && is_user_connected(id) && is_user_bot(id) )
	{
		RegisterHamFromEntity(Ham_Killed, id, "Player_Killed")
		g_bCzBotRegistered = true
	}
}

public Event_HLTV_New_Round()
{
	new iWpnBx
	new szWeaponBox[] = "weaponbox"
	while( (iWpnBx = find_ent_by_class(iWpnBx, szWeaponBox)) > 0 )
	{
		// make sure we only remove our weaponboxes
		if( pev(iWpnBx, pev_iuser3) == WPNBX_CUSTOM )
		{
			WeaponBox_Killed(iWpnBx)
		}
	}
}

public Player_Killed( id )
{
	new iActiveItem = get_pdata_cbase(id, m_pActiveItem, XTRA_OFS_PLAYER)
	new bLaunch
	if( pev_valid( iActiveItem ) )
	{
		if(	NADES_BS & (1<<cs_get_weapon_id(iActiveItem))
		&&	get_pdata_float(iActiveItem, m_flPinPulledOutTime, XTRA_OFS_WEAPON) > -1.0	)
		{
			bLaunch = true
		}
		else
		{
			ExecuteHam(Ham_Item_Holster, iActiveItem, 1)
		}
	}

	new iWeapon, iWeaponBox, iAmmoId, iBpAmmo, iNextWeapon
	new szWeapon[20], szModel[26]
	new Float:flOrigin[3], Float:flAngles[3], Float:flWpnBxVelocity[3]
	
	pev(id, pev_origin, flOrigin)
	pev(id, pev_angles, flAngles)

	flAngles[0] = 0.0
	flAngles[2] = 0.0

	static const weaponbox[] = "weaponbox"

	for(new i; i<sizeof(m_rgpPlayerItems_plr); i++)
	{
		iWeapon = get_pdata_cbase(id, m_rgpPlayerItems_plr[i], XTRA_OFS_PLAYER)
		while( pev_valid( iWeapon ) )
		{
			iNextWeapon = get_pdata_cbase(iWeapon, m_pNext, XTRA_OFS_WEAPON)
			if( i != 2 || !bLaunch || iWeapon != iActiveItem )
			{
				iWeaponBox = create_entity(weaponbox)
				if( pev_valid(iWeaponBox) )
				{
					set_pev(iWeaponBox, pev_iuser3, WPNBX_CUSTOM)

					set_pev(iWeaponBox, pev_owner, id)

					engfunc(EngFunc_SetOrigin, iWeaponBox, flOrigin)

					set_pev(iWeaponBox, pev_angles, flAngles)
					ExecuteHamB(Ham_Spawn, iWeaponBox)

					flWpnBxVelocity[0] = random_float(-250.0,250.0)
					flWpnBxVelocity[1] = random_float(-250.0,250.0)
					set_pev(iWeaponBox, pev_velocity, flWpnBxVelocity)

					if( !WeaponBox_PackWeapon(iWeaponBox, iWeapon, id) )
					{
						set_pev(iWeaponBox, pev_flags, FL_KILLME)
					}
					else
					{
						iAmmoId = ExecuteHam(Ham_Item_PrimaryAmmoIndex, iWeapon)

						iBpAmmo = get_pdata_int(id, m_rgAmmo_Player_Slot0 + iAmmoId, XTRA_OFS_PLAYER)
						set_pdata_int(id, m_rgAmmo_Player_Slot0 + iAmmoId, 0, XTRA_OFS_PLAYER)				

						WeaponBox_PackAmmo(iWeaponBox, iAmmoId, iBpAmmo)

						pev(iWeapon, pev_classname, szWeapon, charsmax(szWeapon))

						replace(szWeapon, charsmax(szWeapon), "navy", "")
						formatex(szModel, charsmax(szModel), "models/w_%s.mdl", szWeapon[7])

						entity_set_model(iWeaponBox, szModel)

						const SILENT_WPN_BS = (1<<CSW_USP)|(1<<CSW_M4A1)

						if(	g_iNoSilPluginId > 0
						&&	g_iNoSilSetModel > 0
						&&	(1<<cs_get_weapon_id(iWeapon)) & SILENT_WPN_BS	)
						{
							callfunc_begin_i(g_iNoSilSetModel, g_iNoSilPluginId)
							callfunc_push_int(iWeaponBox)
							callfunc_push_str(szModel)
							callfunc_end()
						}

					}
				}
			}
			iWeapon = iNextWeapon
		}
	}
	return HAM_HANDLED
}

WeaponBox_PackWeapon(iWeaponBox, iWeapon, id)
{
	if( !ExecuteHam(Ham_RemovePlayerItem, id, iWeapon) )
	{
		return 0
	}

	new iWeaponSlot = ExecuteHam(Ham_Item_ItemSlot, iWeapon)

	set_pdata_cbase(iWeaponBox, m_rgpPlayerItems_wpnbx[ iWeaponSlot ], iWeapon, XTRA_OFS_WEAPONBOX)
	set_pdata_cbase(iWeapon, m_pNext, -1, XTRA_OFS_WEAPON)

	set_pev(iWeapon, pev_spawnflags, pev(iWeapon, pev_spawnflags) | SF_NORESPAWN)
	set_pev(iWeapon, pev_movetype, MOVETYPE_NONE)
	set_pev(iWeapon, pev_solid, SOLID_NOT)
	set_pev(iWeapon, pev_effects, EF_NODRAW)
	set_pev(iWeapon, pev_modelindex, 0)
	set_pev(iWeapon, pev_model, 0)
	set_pev(iWeapon, pev_owner, iWeaponBox)
	set_pdata_cbase(iWeapon, m_pPlayer, -1, XTRA_OFS_WEAPON)

	return 1
}

WeaponBox_Killed(iWpnBx)
{
	new iWeapon
	for(new i=0; i<sizeof(m_rgpPlayerItems_wpnbx); i++)
	{
		iWeapon = get_pdata_cbase(iWpnBx, m_rgpPlayerItems_wpnbx[ i ], XTRA_OFS_WEAPONBOX)
		if( pev_valid(iWeapon) )
		{
			set_pev(iWeapon, pev_flags, FL_KILLME)
		}
		// don't implement pNext system as it's a custom weaponbox that doesn't use it
	}
	set_pev(iWpnBx, pev_flags, FL_KILLME)
}

WeaponBox_PackAmmo(iWeaponBox, iAmmoId, iCount)
{
	new iMaxCarry = g_iMaxAmmo[iAmmoId]

	if( iCount > iMaxCarry )
	{
		iCount = iMaxCarry
	}

	set_pdata_int(iWeaponBox, m_rgiszAmmo_Slot0, g_iszAmmoNames[iAmmoId], XTRA_OFS_WEAPONBOX)	
	set_pdata_int(iWeaponBox, m_rgAmmo_Slot0, iCount, XTRA_OFS_WEAPONBOX)
}